local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()
	a.Flash("Legacy of the Emperor")
	a.Flash("Spear Hand Strike", "Paralysis", "Leg Sweep as Interrupt") -- interrupt casters
	a.Flash("Fortifying Brew") -- emergency CD for every spec
	a.FlashAll("Nimble Brew", "Tiger's Lust", "Charging Ox Wave", "Dampen Harm", "Diffuse Magic") -- Talents
	x.TimeToDie = s.TimeToDie("target") or 10
	x.Chi = s.Power("player", SPELL_POWER_CHI )
	x.MaxChi = s.MaxPower("player", SPELL_POWER_CHI)
	x.Energy = s.Power("player", SPELL_POWER_ENERGY )
	x.InCombat = s.InCombat()
	x.GCD = s.GlobalCooldown()
	x.Spec = s.TalentMastery()
	x.AoE = a.AoE()
	if x.Spec == 1 then
		-- Brewmaster
		x.ShuffleDuration = s.BuffDuration(115307--[[Shuffle]], "player")
		x.EnergyPerSecond = a.energyRegeneration()
		a.Flash("Stance of the Sturdy Ox")
		a.FlashAll("Clash", "Roll") -- if we are not in range, use these
		a.Flash("Provoke") -- taunt if tanking and not keeping aggro
		a.Flash("Dizzying Haze") -- something to do at range, while kiting or to set up a Breath of Fire
		a.Flash("Rushing Jade Wind (Range, Brewmaster)",
				"Blackout Kick (Brewmaster)",
				"Keg Smash",
				"Tiger Palm Buff (Brewmaster)",
		        "Rushing Jade Wind (AoE, Brewmaster)",
				"Expel Harm (Brewmaster)",
				"Guard",
				"Chi Wave", "Zen Sphere", "Chi Burst", 
				"Leg Sweep in AoE",
				"Breath of Fire",
				"BoK at full Chi",
				"Spinning Crane Kick (Brewmaster)",
				"Jab (Brewmaster)",
				"BoK to avoid capping",
				"Tiger Palm (Brewmaster)")
		a.Flash("Elusive Brew") -- flash Elusive Brew at 3 Stacks
		a.FlashAll("Healing Elixiers", "Purify Moderate Stagger", "Purify Heavy Stagger") -- emergency buttons for Brewmasters
	elseif x.Spec == 2 then
		-- Mistweaver
		a.Flash("Stance of the Wise Serpent")
	elseif x.Spec == 3 then
		-- Windwalker
		x.EnergyPerSecond = a.energyRegeneration()
		x.TimeToMax = ((100 - x.Energy) / x.EnergyPerSecond) - s.GlobalCooldown()
		x.Bloodlust = a.Bloodlust()
		a.Flash("Stance of the Fierce Tiger")
		a.Flash("Legacy of the White Tiger")
		a.Flash("Flying Serpent Kick", "Roll")
		if x.AoE then
			a.Flash("Auto Attack",
			        "Potion with Bloodlust or TTD <= 60",
			        "Synapse Springs",
					"Berserking",
					"Chi Brew",
					"Tiger Palm w/ Tiger Power <= 3",
					"Tigereye Brew",
					"Energizing Brew",
					"Blood Fury",
					"Rising Sun Kick (Debuff)",
					"Tiger Palm w/o Tiger Power",
					"Invoke Xuen, the White Tiger",
					"Rushing Jade Wind",
					"Rising Sun Kick at 4+ Chi",
					"Spinning Crane Kick (WW)")
		elseif not s.Channeling(nil, "player") then
			a.Flash("Auto Attack",
			        "Potion with Bloodlust or TTD <= 60",
					"Chi Brew",
					"Tiger Palm w/ Tiger Power <= 3",
					"Tigereye Brew",
					"Energizing Brew",
			        "Synapse Springs",
					"Berserking",
					"Blood Fury",
					"Rising Sun Kick (Debuff)",
					"Tiger Palm w/o Tiger Power",
					"Invoke Xuen, the White Tiger",
					"Rising Sun Kick",
					"Fists of Fury",
					"Chi Wave w/ time to max energy > 2",
					"Combo Breaker: Blackout Kick",
					"Combo Breaker: Tiger Palm",
					"Expel Harm (Windwalker)",
					"Jab (Windwalker)",
					"Blackout Kick w/o disturbing RSK")
		end
	end
end)
